var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);
var abc_flyout_exports = {};
__export(abc_flyout_exports, {
  AbcFlyout: () => AbcFlyout,
  defineCustomElement: () => defineCustomElement
});
module.exports = __toCommonJS(abc_flyout_exports);
var import_client = require("@stencil/core/internal/client");
const flyoutCss = ":host .flyout{box-sizing:border-box;list-style:none;background-color:#f5f5f5;border-color:#ddd;line-height:1.5;letter-spacing:0.5px;text-decoration:none;font:16px Arial, sans-serif;padding-top:10px;padding-bottom:10px;border-radius:4px;border-width:1px;box-shadow:2px 2px 4px rgba(0, 0, 0, 0.2)}";
const isHTMLAbcFlyoutItemElement = (element) => {
  if (typeof element === "object" && typeof element.item === "string") {
    return true;
  }
  return false;
};
const Flyout = /* @__PURE__ */ (0, import_client.proxyCustomElement)(class Flyout2 extends import_client.HTMLElement {
  constructor() {
    super();
    this.__registerHost();
    this.__attachShadow();
    this.flyoutChange = (0, import_client.createEvent)(this, "flyoutChange", 7);
    this.selectedItem = void 0;
  }
  onFlyoutChange() {
    this.flyoutChange.emit(this.selectedItem);
  }
  async handleKeyDown(e) {
    if (!(e.key === "ArrowDown" || e.key === "ArrowUp")) {
      return;
    }
    const items = this.items;
    let currentIndex = items.findIndex((item) => item === document.activeElement);
    if (currentIndex === -1) {
      return;
    }
    if (e.key === "ArrowDown") {
      currentIndex = (currentIndex + 1) % items.length;
    } else if (e.key === "ArrowUp") {
      currentIndex = (currentIndex - 1 + items.length) % items.length;
    }
    await items[currentIndex].focusItem();
    e.preventDefault();
  }
  select(item) {
    if (this.selectedItem === item) {
      return false;
    }
    this.selectedItem = item;
    return true;
  }
  get items() {
    return Array.from(this.host.querySelectorAll("abc-flyout-item"));
  }
  getItems(item) {
    return isHTMLAbcFlyoutItemElement(item) ? item : this.items.find((t) => t.item === item);
  }
  componentWillRender() {
    const selectedItem = this.getItems(this.selectedItem);
    this.items.forEach((item) => {
      item.selected = false;
    });
    if (selectedItem) {
      selectedItem.selected = true;
    }
  }
  render() {
    return (0, import_client.h)(import_client.Host, { onItemClick: ({ detail: { item } }) => {
      this.select(item);
    } }, (0, import_client.h)("div", { class: "flyout" }, (0, import_client.h)("slot", null)));
  }
  get host() {
    return this;
  }
  static get watchers() {
    return {
      "selectedItem": ["onFlyoutChange"]
    };
  }
  static get style() {
    return flyoutCss;
  }
}, [1, "abc-flyout", {
  "selectedItem": [513, "selected-item"]
}, [[10, "keydown", "handleKeyDown"]], {
  "selectedItem": ["onFlyoutChange"]
}]);
function defineCustomElement$1() {
  if (typeof customElements === "undefined") {
    return;
  }
  const components = ["abc-flyout"];
  components.forEach((tagName) => {
    switch (tagName) {
      case "abc-flyout":
        if (!customElements.get(tagName)) {
          customElements.define(tagName, Flyout);
        }
        break;
    }
  });
}
const AbcFlyout = Flyout;
const defineCustomElement = defineCustomElement$1;
