var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);
var utils_exports = {};
__export(utils_exports, {
  NATIVE_GLOBAL_EVENTS: () => NATIVE_GLOBAL_EVENTS,
  omitEventCallbacks: () => omitEventCallbacks,
  toNativeAttributeName: () => toNativeAttributeName,
  toNativeAttributeValue: () => toNativeAttributeValue,
  toNativeProps: () => toNativeProps,
  toPascalCase: () => toPascalCase,
  useEventListeners: () => useEventListeners
});
module.exports = __toCommonJS(utils_exports);
var import_react = require("react");
const REACT_PROP_TO_ATTRIBUTE_NAME_MAP = {
  className: "class",
  classname: "class",
  htmlFor: "for",
  crossOrigin: "crossorigin",
  viewBox: "viewBox"
};
const NATIVE_GLOBAL_EVENTS = [
  "animationcancel",
  "animationend",
  "animationiteration",
  "animationstart",
  "beforeinput",
  "blur",
  "cancel",
  "change",
  "click",
  "close",
  "contextmenu",
  "copy",
  "cut",
  "dblclick",
  "drag",
  "dragend",
  "dragenter",
  "dragleave",
  "dragover",
  "dragstart",
  "drop",
  "emptied",
  "error",
  "focus",
  "focusin",
  "focusout",
  "formdata",
  "input",
  "invalid",
  "keydown",
  "keypress",
  "keyup",
  "mousedown",
  "mouseenter",
  "mouseleave",
  "mousemove",
  "mouseout",
  "mouseover",
  "mouseup",
  "pointercancel",
  "pointerdown",
  "pointerenter",
  "pointerleave",
  "pointermove",
  "pointerout",
  "pointerover",
  "pointerup",
  "reset",
  "resize",
  "scroll",
  "scrollend",
  "select",
  "selectionchange",
  "selectstart",
  "slotchange",
  "submit",
  "toggle",
  "touchcancel",
  "touchend",
  "touchmove",
  "touchstart",
  "transitioncancel",
  "transitionend",
  "transitionrun",
  "transitionstart",
  "wheel"
];
const omitEventCallbacks = (customEvents, props) => {
  const eventCallbacks = [...customEvents, ...NATIVE_GLOBAL_EVENTS].map((event) => toCallbackName(event));
  return Object.fromEntries(Object.entries(props).filter(([key]) => !eventCallbacks.includes(key)));
};
const clearAndUpper = (text) => text.replace(/-/, "").toUpperCase();
const toPascalCase = (kebabText) => kebabText.replace(/(^\w|-\w)/g, clearAndUpper);
const toCallbackName = (name) => `on${toPascalCase(name)}`;
const useEventListeners = (ref, customEvents, props) => {
  const events = [...customEvents, ...NATIVE_GLOBAL_EVENTS];
  (0, import_react.useEffect)(() => {
    const { current } = ref;
    if (!current) {
      return;
    }
    for (const event of events) {
      const callback = props[toCallbackName(event)];
      if (callback) {
        current.addEventListener(event, props[toCallbackName(event)]);
      }
    }
    return () => {
      for (const event of events) {
        const callback = props[toCallbackName(event)];
        if (callback) {
          current.removeEventListener(event, props[toCallbackName(event)]);
        }
      }
    };
  }, [ref]);
};
const toNativeAttributeName = (name, value) => {
  if (REACT_PROP_TO_ATTRIBUTE_NAME_MAP[name]) {
    return REACT_PROP_TO_ATTRIBUTE_NAME_MAP[name];
  }
  if (typeof value == "undefined" || typeof value === "boolean" && !value) {
    return void 0;
  }
  if (/[A-Z]/.test(name)) {
    return name.toLowerCase();
  }
  return name;
};
const toNativeAttributeValue = (value) => typeof value === "boolean" ? "" : Array.isArray(value) ? value.join(" ") : value;
const toNativeProps = (props = {}) => Object.entries(props).reduce((transformedProps, [name, value]) => {
  const attributeName = toNativeAttributeName(name, value);
  if (attributeName) {
    transformedProps[attributeName] = toNativeAttributeValue(value);
  }
  return transformedProps;
}, {});
