'use client';

import { defineCustomElement } from './components/abc-accordion-group.js';
import React, { useEffect, useRef, useState } from 'react';

export const AbcAccordionGroupUseClient = ({
  ssrHtml,
  children,
  ...props
}) => {
  const refPlaceholder = useRef(null);
  const [isClient, setIsClient] = useState(false);
  useEffect(() => {
    refPlaceholder.current?.remove();
    if (typeof customElements !== 'undefined' && !customElements.get('abc-accordion-group')) {
      defineCustomElement();
    }
    setIsClient(true);
  }, []);


  return React.createElement('div', { children: [
    React.createElement('div', { ref: refPlaceholder, key: 'abc-accordion-group-placeholder', dangerouslySetInnerHTML: { __html: ssrHtml } }),
    isClient && React.createElement('abc-accordion-group', { ...props, key: 'abc-accordion-group' }, children),
  ]});
};