import { renderToString } from './hydrate';
import { AbcAccordionUseClient } from './abc-accordion.use-client';
import React from 'react';

export const AbcAccordionSSR = async ({ children, ...props }) => {
  const { html } = await renderToString(
    `<abc-accordion ${Object.entries(props)
  .map(([key, value]) => `${key}="${value}"`)
  .join(' ')}>${children}</abc-accordion>`,
  );
  const componentStyles = html.match(/<style[^>]*>([\s\S]*?)<\/style>/i)?.[1] ?? '';
  const componentHtml = html.match(/<body[^>]*>([\s\S]*?)<\/body/i)?.[1] ?? '';

  return React.createElement(AbcAccordionUseClient, { ...props, children, ssrHtml: `<style>${componentStyles}</style>${componentHtml}` });
};