import { renderToString } from './hydrate';
import { AbcDropdownButtonUseClient } from './abc-dropdown-button.use-client';
import React from 'react';

export const AbcDropdownButtonSSR = async ({ children, ...props }) => {
  const { html } = await renderToString(
    `<abc-dropdown-button ${Object.entries(props)
  .map(([key, value]) => `${key}="${value}"`)
  .join(' ')}>${children}</abc-dropdown-button>`,
  );
  const componentStyles = html.match(/<style[^>]*>([\s\S]*?)<\/style>/i)?.[1] ?? '';
  const componentHtml = html.match(/<body[^>]*>([\s\S]*?)<\/body/i)?.[1] ?? '';

  return React.createElement(AbcDropdownButtonUseClient, { ...props, children, ssrHtml: `<style>${componentStyles}</style>${componentHtml}` });
};