import { renderToString } from './hydrate';
import { AbcFlyoutUseClient } from './abc-flyout.use-client';
import React from 'react';

export const AbcFlyoutSSR = async ({ children, ...props }) => {
  const { html } = await renderToString(
    `<abc-flyout ${Object.entries(props)
  .map(([key, value]) => `${key}="${value}"`)
  .join(' ')}>${children}</abc-flyout>`,
  );
  const componentStyles = html.match(/<style[^>]*>([\s\S]*?)<\/style>/i)?.[1] ?? '';
  const componentHtml = html.match(/<body[^>]*>([\s\S]*?)<\/body/i)?.[1] ?? '';

  return React.createElement(AbcFlyoutUseClient, { ...props, children, ssrHtml: `<style>${componentStyles}</style>${componentHtml}` });
};