'use client';

import { defineCustomElement } from './components/abc-flyout.js';
import React, { useEffect, useRef, useState } from 'react';

export const AbcFlyoutUseClient = ({
  ssrHtml,
  children,
  ...props
}) => {
  const refPlaceholder = useRef(null);
  const [isClient, setIsClient] = useState(false);
  useEffect(() => {
    refPlaceholder.current?.remove();
    if (typeof customElements !== 'undefined' && !customElements.get('abc-flyout')) {
      defineCustomElement();
    }
    setIsClient(true);
  }, []);


  return React.createElement('div', { children: [
    React.createElement('div', { ref: refPlaceholder, key: 'abc-flyout-placeholder', dangerouslySetInnerHTML: { __html: ssrHtml } }),
    isClient && React.createElement('abc-flyout', { ...props, key: 'abc-flyout' }, children),
  ]});
};