import { renderToString } from './hydrate';
import { AbcIconChevronDownUseClient } from './abc-icon-chevron-down.use-client';
import React from 'react';

export const AbcIconChevronDownSSR = async ({ children, ...props }) => {
  const { html } = await renderToString(
    `<abc-icon-chevron-down ${Object.entries(props)
  .map(([key, value]) => `${key}="${value}"`)
  .join(' ')}>${children}</abc-icon-chevron-down>`,
  );
  const componentStyles = html.match(/<style[^>]*>([\s\S]*?)<\/style>/i)?.[1] ?? '';
  const componentHtml = html.match(/<body[^>]*>([\s\S]*?)<\/body/i)?.[1] ?? '';

  return React.createElement(AbcIconChevronDownUseClient, { ...props, children, ssrHtml: `<style>${componentStyles}</style>${componentHtml}` });
};