import { proxyCustomElement, HTMLElement, createEvent, h } from '@stencil/core/internal/client';
import { I as ICON_SIZES, d as defineCustomElement$1 } from './chevron-down.js';

const dropdownButtonCss = ":host .dropdown-button{box-sizing:border-box;color:#333;display:flex;flex-direction:column;font:16px Arial, sans-serif;letter-spacing:1px;line-height:1.5;margin-bottom:10px;text-decoration:none;text-transform:uppercase}:host .dropdown-button__wrapper{background-color:#f0f0f0;border-color:#ccc;border-radius:4px;border-width:2px;border-style:solid;box-shadow:0 2px 4px rgba(0, 0, 0, 0.1);font:14px Arial, sans-serif;letter-spacing:1px;line-height:1.4;min-height:30px;margin:5px 0;padding:8px 12px;text-decoration:none;text-transform:uppercase;display:flex;flex-direction:row;justify-content:space-between;align-items:center}:host .dropdown-button__wrapper:focus-within{background-color:#e0e0e0;border-color:#007bff;box-shadow:0 2px 4px rgba(0, 0, 0, 0.2);color:#007bff}:host .dropdown-button__button{font:14px Arial, sans-serif;letter-spacing:1px;line-height:1.4;text-decoration:none;text-transform:uppercase;background-color:#f0f0f0;border:none;flex-grow:1;padding:0;outline:none;display:flex;flex-direction:row;justify-content:space-between}:host .dropdown-button__icon{color:#555;transition:0.3s ease-in-out}:host .dropdown-button__text{color:#999}:host .dropdown-button.focused{border-radius:4px;color:#007bff;outline-color:#007bff;outline-style:solid;outline-width:2px;outline-offset:2px}:host .dropdown-button :host .dropdown-button__wrapper:focus-within :host .dropdown-button__button{color:#007bff}:host .dropdown-button :host .dropdown-button__wrapper:focus-within :host .dropdown-button__button svg{color:#007bff}:host([disabled]) .dropdown-button__label{color:#999}:host([disabled]) .dropdown-button__button{color:#999;background-color:#f0f0f0}:host([disabled]) .dropdown-button__text{color:#999}:host([disabled]) .dropdown-button__wrapper{background-color:#f0f0f0;border-color:#ccc}:host([disabled]) .dropdown-button__icon{color:#999}:host([required]) .asterisk{margin-left:5px}:host([error]) .dropdown-button__label{color:#ff0000}:host([error]) .dropdown-button__wrapper{background-color:#ffeeee;border-color:#ff0000;box-shadow:0 0 4px rgba(255, 0, 0, 0.5);color:#ff0000}:host([error]) .dropdown-button__button{color:#ff0000}:host([error]) .dropdown-button__text{color:#ff0000}:host([open]) .dropdown-button__icon{transform:rotate(180deg)}";

const DropdownButton = /*@__PURE__*/ proxyCustomElement(class DropdownButton extends HTMLElement {
    constructor() {
        super();
        this.__registerHost();
        this.__attachShadow();
        this.dropdownButtonFocus = createEvent(this, "dropdownButtonFocus", 7);
        this.dropdownButtonBlur = createEvent(this, "dropdownButtonBlur", 7);
        this.dropdownButtonClick = createEvent(this, "dropdownButtonClick", 7);
        this.disabled = false;
        this.required = false;
        this.placeholder = false;
        this.label = undefined;
        this.text = undefined;
        this.open = false;
        this.focused = false;
    }
    render() {
        return (h("label", { class: `dropdown-button ${this.required ? 'required' : ''} ${this.disabled ? 'disabled' : ''} ${this.focused ? 'focused' : ''}` }, this.label && (h("div", { class: "dropdown-button__label" }, this.label, " ", this.required && h("span", { class: "asterisk" }, "*"))), h("div", { class: "dropdown-button__wrapper" }, h("button", { onFocus: () => this.dropdownButtonFocus.emit(), onBlur: () => this.dropdownButtonBlur.emit(), class: "dropdown-button__button", disabled: this.disabled, onClick: () => this.dropdownButtonClick.emit(), "aria-haspopup": "listbox", "aria-expanded": this.open }, h("div", { class: this.placeholder ? 'dropdown-button__text' : '' }, this.text), h("abc-icon-chevron-down", { class: "dropdown-button__icon", size: ICON_SIZES.SM }))), h("slot", null)));
    }
    get host() { return this; }
    static get style() { return dropdownButtonCss; }
}, [1, "abc-dropdown-button", {
        "disabled": [4],
        "required": [4],
        "placeholder": [4],
        "label": [1],
        "text": [1],
        "open": [516],
        "focused": [32]
    }]);
function defineCustomElement() {
    if (typeof customElements === "undefined") {
        return;
    }
    const components = ["abc-dropdown-button", "abc-icon-chevron-down"];
    components.forEach(tagName => { switch (tagName) {
        case "abc-dropdown-button":
            if (!customElements.get(tagName)) {
                customElements.define(tagName, DropdownButton);
            }
            break;
        case "abc-icon-chevron-down":
            if (!customElements.get(tagName)) {
                defineCustomElement$1();
            }
            break;
    } });
}

export { DropdownButton as D, defineCustomElement as d };

//# sourceMappingURL=dropdown-button.js.map