import type { Components, ACCORDION_VARIANTS, BUTTON_SIZES, BUTTON_TYPE, BUTTON_VARIANTS, ICON_SIZES, AbcAccordionGroupCustomEvent, AbcAccordionCustomEvent, AbcButtonCustomEvent, AbcDropdownButtonCustomEvent, AbcDropdownCustomEvent, AbcFlyoutItemCustomEvent, AbcFlyoutCustomEvent, AbcIconChevronDownCustomEvent } from 'abc-web-components';
import type React from 'react';

type GlobalEventHandlers = {
onAnimationcancel: (event: GlobalEventHandlersEventMap['animationcancel']) => void,
onAnimationend: (event: GlobalEventHandlersEventMap['animationend']) => void,
onAnimationiteration: (event: GlobalEventHandlersEventMap['animationiteration']) => void,
onAnimationstart: (event: GlobalEventHandlersEventMap['animationstart']) => void,
onBeforeinput: (event: GlobalEventHandlersEventMap['beforeinput']) => void,
onBlur: (event: GlobalEventHandlersEventMap['blur']) => void,
onCancel: (event: GlobalEventHandlersEventMap['cancel']) => void,
onChange: (event: GlobalEventHandlersEventMap['change']) => void,
onClick: (event: GlobalEventHandlersEventMap['click']) => void,
onClose: (event: GlobalEventHandlersEventMap['close']) => void,
onContextmenu: (event: GlobalEventHandlersEventMap['contextmenu']) => void,
onCopy: (event: GlobalEventHandlersEventMap['copy']) => void,
onCut: (event: GlobalEventHandlersEventMap['cut']) => void,
onDblclick: (event: GlobalEventHandlersEventMap['dblclick']) => void,
onDrag: (event: GlobalEventHandlersEventMap['drag']) => void,
onDragend: (event: GlobalEventHandlersEventMap['dragend']) => void,
onDragenter: (event: GlobalEventHandlersEventMap['dragenter']) => void,
onDragleave: (event: GlobalEventHandlersEventMap['dragleave']) => void,
onDragover: (event: GlobalEventHandlersEventMap['dragover']) => void,
onDragstart: (event: GlobalEventHandlersEventMap['dragstart']) => void,
onDrop: (event: GlobalEventHandlersEventMap['drop']) => void,
onEmptied: (event: GlobalEventHandlersEventMap['emptied']) => void,
onError: (event: GlobalEventHandlersEventMap['error']) => void,
onFocus: (event: GlobalEventHandlersEventMap['focus']) => void,
onFocusin: (event: GlobalEventHandlersEventMap['focusin']) => void,
onFocusout: (event: GlobalEventHandlersEventMap['focusout']) => void,
onFormdata: (event: GlobalEventHandlersEventMap['formdata']) => void,
onInput: (event: GlobalEventHandlersEventMap['input']) => void,
onInvalid: (event: GlobalEventHandlersEventMap['invalid']) => void,
onKeydown: (event: GlobalEventHandlersEventMap['keydown']) => void,
onKeypress: (event: GlobalEventHandlersEventMap['keypress']) => void,
onKeyup: (event: GlobalEventHandlersEventMap['keyup']) => void,
onMousedown: (event: GlobalEventHandlersEventMap['mousedown']) => void,
onMouseenter: (event: GlobalEventHandlersEventMap['mouseenter']) => void,
onMouseleave: (event: GlobalEventHandlersEventMap['mouseleave']) => void,
onMousemove: (event: GlobalEventHandlersEventMap['mousemove']) => void,
onMouseout: (event: GlobalEventHandlersEventMap['mouseout']) => void,
onMouseover: (event: GlobalEventHandlersEventMap['mouseover']) => void,
onMouseup: (event: GlobalEventHandlersEventMap['mouseup']) => void,
onPointercancel: (event: GlobalEventHandlersEventMap['pointercancel']) => void,
onPointerdown: (event: GlobalEventHandlersEventMap['pointerdown']) => void,
onPointerenter: (event: GlobalEventHandlersEventMap['pointerenter']) => void,
onPointerleave: (event: GlobalEventHandlersEventMap['pointerleave']) => void,
onPointermove: (event: GlobalEventHandlersEventMap['pointermove']) => void,
onPointerout: (event: GlobalEventHandlersEventMap['pointerout']) => void,
onPointerover: (event: GlobalEventHandlersEventMap['pointerover']) => void,
onPointerup: (event: GlobalEventHandlersEventMap['pointerup']) => void,
onReset: (event: GlobalEventHandlersEventMap['reset']) => void,
onResize: (event: GlobalEventHandlersEventMap['resize']) => void,
onScroll: (event: GlobalEventHandlersEventMap['scroll']) => void,
onScrollend: (event: GlobalEventHandlersEventMap['scrollend']) => void,
onSelect: (event: GlobalEventHandlersEventMap['select']) => void,
onSelectionchange: (event: GlobalEventHandlersEventMap['selectionchange']) => void,
onSelectstart: (event: GlobalEventHandlersEventMap['selectstart']) => void,
onSlotchange: (event: GlobalEventHandlersEventMap['slotchange']) => void,
onSubmit: (event: GlobalEventHandlersEventMap['submit']) => void,
onToggle: (event: GlobalEventHandlersEventMap['toggle']) => void,
onTouchcancel: (event: GlobalEventHandlersEventMap['touchcancel']) => void,
onTouchend: (event: GlobalEventHandlersEventMap['touchend']) => void,
onTouchmove: (event: GlobalEventHandlersEventMap['touchmove']) => void,
onTouchstart: (event: GlobalEventHandlersEventMap['touchstart']) => void,
onTransitioncancel: (event: GlobalEventHandlersEventMap['transitioncancel']) => void,
onTransitionend: (event: GlobalEventHandlersEventMap['transitionend']) => void,
onTransitionrun: (event: GlobalEventHandlersEventMap['transitionrun']) => void,
onTransitionstart: (event: GlobalEventHandlersEventMap['transitionstart']) => void,
onWheel: (event: GlobalEventHandlersEventMap['wheel']) => void
};
type IsEnum<T> = T extends ACCORDION_VARIANTS | BUTTON_SIZES | BUTTON_TYPE | BUTTON_VARIANTS | ICON_SIZES ? true : false;
type EnumsToStringLiterals<T> = {
  [K in keyof T]: Exclude<IsEnum<T[K]> extends true ? `${T[K]}` : T[K], 'undefined'>;
};

declare const AbcAccordionGroup: React.ForwardRefExoticComponent<React.PropsWithChildren<Partial<EnumsToStringLiterals<Components.AbcAccordionGroup> & {
    slot: string
  } & GlobalEventHandlers & {
    onAccordionChange: (event: AbcAccordionGroupCustomEvent<HTMLAbcAccordionGroupElementEventMap['accordionChange']>) => void
  }>> & React.RefAttributes<HTMLElement | undefined>>;
  declare const AbcAccordionGroupSSR: React.ForwardRefExoticComponent<React.PropsWithChildren<Partial<EnumsToStringLiterals<Components.AbcAccordionGroup> & {
    slot: string
  }>> & React.RefAttributes<HTMLElement | undefined>>;
declare const AbcAccordion: React.ForwardRefExoticComponent<React.PropsWithChildren<Partial<EnumsToStringLiterals<Components.AbcAccordion> & {
    slot: string
  } & GlobalEventHandlers & {
    onAccordionClick: (event: AbcAccordionCustomEvent<HTMLAbcAccordionElementEventMap['accordionClick']>) => void
  }>> & React.RefAttributes<HTMLElement | undefined>>;
  declare const AbcAccordionSSR: React.ForwardRefExoticComponent<React.PropsWithChildren<Partial<EnumsToStringLiterals<Components.AbcAccordion> & {
    slot: string
  }>> & React.RefAttributes<HTMLElement | undefined>>;
declare const AbcButton: React.ForwardRefExoticComponent<React.PropsWithChildren<Partial<EnumsToStringLiterals<Components.AbcButton> & {
    slot: string
  } & GlobalEventHandlers>> & React.RefAttributes<HTMLElement | undefined>>;
  declare const AbcButtonSSR: React.ForwardRefExoticComponent<React.PropsWithChildren<Partial<EnumsToStringLiterals<Components.AbcButton> & {
    slot: string
  }>> & React.RefAttributes<HTMLElement | undefined>>;
declare const AbcDropdownButton: React.ForwardRefExoticComponent<React.PropsWithChildren<Partial<EnumsToStringLiterals<Components.AbcDropdownButton> & {
    slot: string
  } & GlobalEventHandlers & {
    onDropdownButtonFocus: (event: AbcDropdownButtonCustomEvent<HTMLAbcDropdownButtonElementEventMap['dropdownButtonFocus']>) => void,
  onDropdownButtonBlur: (event: AbcDropdownButtonCustomEvent<HTMLAbcDropdownButtonElementEventMap['dropdownButtonBlur']>) => void,
  onDropdownButtonClick: (event: AbcDropdownButtonCustomEvent<HTMLAbcDropdownButtonElementEventMap['dropdownButtonClick']>) => void
  }>> & React.RefAttributes<HTMLElement | undefined>>;
  declare const AbcDropdownButtonSSR: React.ForwardRefExoticComponent<React.PropsWithChildren<Partial<EnumsToStringLiterals<Components.AbcDropdownButton> & {
    slot: string
  }>> & React.RefAttributes<HTMLElement | undefined>>;
declare const AbcDropdown: React.ForwardRefExoticComponent<React.PropsWithChildren<Partial<EnumsToStringLiterals<Components.AbcDropdown> & {
    slot: string
  } & GlobalEventHandlers & {
    onDropdownChange: (event: AbcDropdownCustomEvent<HTMLAbcDropdownElementEventMap['dropdownChange']>) => void
  }>> & React.RefAttributes<HTMLElement | undefined>>;
  declare const AbcDropdownSSR: React.ForwardRefExoticComponent<React.PropsWithChildren<Partial<EnumsToStringLiterals<Components.AbcDropdown> & {
    slot: string
  }>> & React.RefAttributes<HTMLElement | undefined>>;
declare const AbcFlyoutItem: React.ForwardRefExoticComponent<React.PropsWithChildren<Partial<EnumsToStringLiterals<Components.AbcFlyoutItem> & {
    slot: string
  } & GlobalEventHandlers & {
    onItemClick: (event: AbcFlyoutItemCustomEvent<HTMLAbcFlyoutItemElementEventMap['itemClick']>) => void
  }>> & React.RefAttributes<HTMLElement | undefined>>;
  declare const AbcFlyoutItemSSR: React.ForwardRefExoticComponent<React.PropsWithChildren<Partial<EnumsToStringLiterals<Components.AbcFlyoutItem> & {
    slot: string
  }>> & React.RefAttributes<HTMLElement | undefined>>;
declare const AbcFlyout: React.ForwardRefExoticComponent<React.PropsWithChildren<Partial<EnumsToStringLiterals<Components.AbcFlyout> & {
    slot: string
  } & GlobalEventHandlers & {
    onFlyoutChange: (event: AbcFlyoutCustomEvent<HTMLAbcFlyoutElementEventMap['flyoutChange']>) => void
  }>> & React.RefAttributes<HTMLElement | undefined>>;
  declare const AbcFlyoutSSR: React.ForwardRefExoticComponent<React.PropsWithChildren<Partial<EnumsToStringLiterals<Components.AbcFlyout> & {
    slot: string
  }>> & React.RefAttributes<HTMLElement | undefined>>;
declare const AbcIconChevronDown: React.ForwardRefExoticComponent<React.PropsWithChildren<Partial<EnumsToStringLiterals<Components.AbcIconChevronDown> & {
    slot: string
  } & GlobalEventHandlers>> & React.RefAttributes<HTMLElement | undefined>>;
  declare const AbcIconChevronDownSSR: React.ForwardRefExoticComponent<React.PropsWithChildren<Partial<EnumsToStringLiterals<Components.AbcIconChevronDown> & {
    slot: string
  }>> & React.RefAttributes<HTMLElement | undefined>>;

export { AbcAccordionGroup,
AbcAccordionGroupSSR,
AbcAccordion,
AbcAccordionSSR,
AbcButton,
AbcButtonSSR,
AbcDropdownButton,
AbcDropdownButtonSSR,
AbcDropdown,
AbcDropdownSSR,
AbcFlyoutItem,
AbcFlyoutItemSSR,
AbcFlyout,
AbcFlyoutSSR,
AbcIconChevronDown,
AbcIconChevronDownSSR };
